Sun, Jul 15, 2012 - xdebug 2.2.1

= Fixed bugs:

	- Fixed bug #843: Text output depends on php locale.
	- Fixed bug #838/#839/#840: Debugging static properties crashes Xdebug.
	- Fixed bug #821: Variable assignments (beginning with =>) should be
	  indented one more scope.
	- Fixed bug #811: PHP Documentation Link.
	- Fixed bug #800: var_dump(get_class(new foo\bar')) add an extra "\" in
	  class name.


Tue, May 08, 2012 - xdebug 2.2.0

+ Added features:

	- Support for PHP 5.4.

	- Added ANSI colour output for the shell. (Including patches by Michael
	  Maclean)
	- Added var_dump() overloading on the command line (issue #457).

	- Added better support for closures in stack and function traces.
	- Added the size of arrays to the overloaded variable output, so that you
	  know how many elements there are.
	- Added support for X-HTTP-FORWARDED-FOR before falling back to REMOTE_ADDR
	  (issue #660). (Patch by Hannes Magnusson)
	- Added the method call type to xdebug_get_function_stack() (issue #695).
	- Added extra information to error printouts to tell that the error
	  suppression operator has been ignored due to xdebug.scream.
	- Added a error-specific CSS class to stack traces.

+ New settings:

	- xdebug.cli_color for colouring output on the command line (Unix only).
	- Added xdebug.trace_enable_trigger to triger function traces through a
	  GET/POST/COOKIE parameter (issue #517). (Patch by Patrick Allaert)
	- Added support for the 'U' format specifier for function trace and
	  profiler filenames.

+ Changes:

	- Improved performance by lazy-initializing data structures.
	- Improved code coverage performance. (Including some patches by Taavi
	  Burns)
	- Improved compatibility with KCacheGrind.
	- Improved logging of remote debugging connections, by added connection
	  success/failure logging to the xdebug.remote_log functionality.

= Fixed bugs:

	- Fixed bug #827: Enabling Xdebug causes phpt tests to fail because of
	  var_dump() formatting issues.
	- Fixed bug #823: Single quotes are escaped in var_dumped string output.
	- Fixed bug #819: Xdebug 2.2.0RC2 can't stand on a breakpoint more than 30
	  seconds.
	- Fixed bug #801: Segfault with streamwrapper and unclosed $fp on
	  destruction.
	- Fixed bug #797: Xdebug crashes when fetching static properties.
	- Fixed bug #794: Allow coloured output on Windows.
	- Fixed bug #784: Unlimited feature for var_display_max_data and
	  var_display_max_depth is undocumented.
	- Fixed bug #774: Apache crashes on header() calls.
	- Fixed bug #764: Tailored Installation instructions do not work.
	- Fixed bug #758: php_value xdebug.idekey is ignored in .htaccess files
	- Fixed bug #728: Profiler reports __call() invocations
	  confusingly/wrongly.
	- Fixed bug #687: Xdebug does not show dynamically defined variable.
	- Fixed bug #662: idekey is set to running user.
	- Fixed bug #627: Added the realpath check.


Mon, Mar 12, 2012 - xdebug 2.1.4

= Fixed bugs:

	- Fixed bug #788: Collect errors eats fatal errors.
	- Fixed bug #787: Segmentation Fault with PHP header_remove().
	- Fixed bug #778: Xdebug session in Eclipse crash whenever it run into
	  simplexml_load_string call.
	- Fixed bug #756: Added support for ZEND_*_*_OBJ and self::*.
	- Fixed bug #747: Still problem with error message and soap client / soap
	  server.
	- Fixed bug #744: new lines in a PHP file from Windows are displayed with
	  an extra white line with var_dump().
	- Fixed an issue with debugging and the eval command.
	- Fixed compilation with ZTS on PHP &lt; 5.3


Wed, Jan 25, 2012 - xdebug 2.1.3

= Fixed bugs:
    
	- Fixed bug #725: EG(current_execute_data) is not checked in xdebug.c,
	  xdebug_statement_call.
	- Fixed bug #723: xdebug is stricter than PHP regarding Exception property
	  types.
	- Fixed bug #714: Cachegrind files have huge (wrong) numbers in some lines.
	- Fixed bug #709: Xdebug doesn&apos;t understand E_USER_DEPRECATED.
	- Fixed bug #698: Allow xdebug.remote_connect_back to be set in .htaccess.
	- Fixed bug #690: Function traces are not appended to file with
	  xdebug_start_trace() and xdebug.trace_options=1.
	- Fixed bug #623: Static properties of a class can be evaluated only with
	  difficulty.
	- Fixed bug #614/#619: Viewing private variables in base classes through
	  the debugger.
	- Fixed bug #609: Xdebug and SOAP extension&apos;s error handlers conflict.
	- Fixed bug #606/#678/#688/#689/#704: crash after using eval on an
	  unparsable, or un-executable statement.
	- Fixed bug #305: xdebug exception handler doesn&apos;t properly handle
	  special chars.

+ Changes:

	- Changed xdebug_break() to hint to the statement execution trap instead of
	  breaking forcefully adding an extra stackframe.
	- Prevent Xdebug 2.1.x to build with PHP 5.4.


Thu, Jul 28, 2011 - xdebug 2.1.2

= Fixed bugs:

	- Fixed bug #622: Working with eval() code is inconvenient and difficult.
	- Fixed bug #684: xdebug_var_dump - IE does not support &amp;.
	- Fixed bug #693: Cachegrind files not written when filename is very long.
	- Fixed bug #697: Incorrect code coverage of function arguments when using
	  XDEBUG_CC_UNUSED.
	- Fixed bug #699: Xdebug gets the filename wrong for the countable
	  interface.
	- Fixed bug #703 by adding another opcode to the list that needs to be
	  overridden.

Mon, Mar 28, 2011 - xdebug 2.1.1

= Fixed bugs:

  - Fixed ZTS compilation.


Tue, Mar 22, 2011 - xdebug 2.1.1rc1

= Fixed bugs:

  = Debugger
	- Fixed bug #518: Removed CLASSNAME pseudo-property optional.
	- Fixed bug #592: Xdebug crashes with run after detach.
	- Fixed bug #596: Call breakpoint never works with instance methods, only
	  static methods.
	- Fixed JIT mode in the debugger so that it works for xdebug_break() too.

  = Profiler
	- Fixed bug #631: Summary not written when script ended with "exit()".
	- Fixed bug #639: Xdebug profiling: output not correct - missing 'cfl='.
	- Fixed bug #642: Fixed line numbers for offsetGet, offsetSet,
	  __get/__set/__isset/__unset and __call in profile files and stack
	  traces/function traces.
	- Fixed bug #643: Profiler gets line numbers wrong.
	- Fixed bug #653: XDebug profiler crashes with %H in file name and non
	  standard port.

  = Others
	- Fixed bug #651: Incorrect code coverage after empty() in conditional.
	- Fixed bug #654: Xdebug hides error message in CLI.
	- Fixed bug #665: Xdebug does not respect display_errors=stderr.
	  Patch by Ben Spencer <dangerous.ben@gmail.com>
	- Fixed bug #670: Xdebug crashes with broken "break x" code.


Tue, Jun 29, 2010 - xdebug 2.1.0

= Fixed bugs:

	- Fixed bug #562: Incorrect coverage information for closure function headers.
	- Fixed bug #566: Xdebug crashes when using conditional breakpoints.
	- Fixed bug #567: xdebug_debug_zval and xdebug_debug_zval_stdout don't work
	  with PHP 5.3. (Patch by Endo Hiroaki).
	- Fixed bug #570: undefined symbol: zend_memrchr.


Thu, Apr 06, 2010 - xdebug 2.1.0rc1

= Fixed bugs:
	- Fixed bug #494: Private attributes of parent class unavailable when
	  inheriting.
	- Fixed bug #400: Xdebug shows errors, even when PHP is request startup
	  mode.
	- Fixed bug #421: xdebug sends back invalid characters in xml sometimes.
	- Fixed bug #475: Property names with null chars are not sent fully to the
	  client.
	- Fixed bug #480: Issues with the reserved resource in multi threaded
	  environments (Patch by Francis.Grolemund@netapp.com).
	- Fixed bug #558: PHP segfaults when running a nested eval.


Sat, Feb 27, 2010 - xdebug 2.1.0beta3

= Fixed bugs:
	- Fixed memory corruption issues.
	- Fixed a threading related issue for code-coverage.
	- Fixed bug #532: XDebug breaks header() function.
	- DBGP: Prevent Xdebug from returning properties when a too high page number
	  has been requested.


Wed, Feb 03, 2010 - xdebug 2.1.0beta2

= Fixed bugs:
	- Fixed memory leak in breakpoint handling.
	- Fixed bug #528: Core dump generated with remote_connect_back option set
	  and CLI usage.
	- Fixed bug #515: declare(ticks) statement confuses code coverage.
	- Fixed bug #512: DBGP: breakpoint_get doesn't return conditions in its
	  response.
	- Possible fix for bug #507/#517: Crashes because of uninitalised header
	  globals.
	- Fixed bug #501: Xdebug's variable tracing misses POST_INC and variants.


Sun, Jan 03, 2010 - xdebug 2.1.0beta1

+ Added features:
	- Added error display collection and suppressions.
	- Added the recording of headers being set in scripts.
	- Added variable assignment tracing.
	- Added the ability to turn of the default overriding of var_dump().
	- Added "Scream" support, which disables the @ operator.
	- Added a trace-file analysing script.
	- Added support for debugging into phars.
	- Added a default xdebug.ini. (Patch by Martin Schuhfuß
	  <martins@spot-media.de>)
	- Added function parameters in computerized function traces.
	- PHP 5.3 compatibility.
	- Improved code coverage accuracy.

  + New functions:
	- xdebug_get_formatted_function_stack(), which returns a formatted function
	  stack instead of displaying it.
	- xdebug_get_headers(), which returns all headers that have been set in a
	  script, both explicitly with things like header(), but also implicitly
	  for things like setcookie().
	- xdebug_start_error_collection(), xdebug_stop_error_collection() and
	  xdebug_get_collected_errors(), which allow you to collect all notices,
	  warnings and error messages that Xdebug generates from PHP's
	  error_reporting functionality so that you can output them at a later
	  point in your script by hand.

  + New settings:
	- xdebug.collect_assignments, which enables the emitting of variable
	  assignments in function traces.
	- xdebug.file_line_format, to generate a link with a specific format for 
	  every filename that Xdebug outputs.
	- xdebug.overload_var_dump, which allows you to turn off Xdebug's version
	  of var_dump().
	- xdebug.remote_cookie_expire_time, that controls the length of a
	  remote debugging session. (Patch by Rick Pannen <pannen@gmail.com>)
	- xdebug.scream, which makes the @ operator to be ignored.

+ Changes:
	- Added return values for xdebug_start_code_coverage() and
	  xdebug_stop_code_coverage() to indicate whether the action was
	  succesfull.  xdebug_start_code_coverage() will return TRUE if the call
	  enabled code coverage, and FALSE if it was already enabled.
	  xdebug_stop_code_coverage() will return FALSE when code coverage wasn't
	  started yet and TRUE if it was turned on.
	- Added an optional argument to xdebug_print_function_stack() to display
	  your own message. (Patch by Mikko Koppanen).
	- All HTML output as generated by Xdebug now has a HTML "class" attribute
	  for easy CSS formatting.

- Removed features:
	- Support for PHP versions lower than PHP 5.1 have been dropped.
	- The PHP3 and GDB debugger engines have been removed.

= Fixed bugs:
	- Fixed support for showing $this in remote debugging sessions.
	- Fixed bug in formatting the display of "Variables in the local scope".
	- Possible fix for a threading issue where the headers gathering function
	  would create stack overflows.
	- Possible fix for #324: xdebug_dump_superglobals() only dumps superglobals
	  that were accessed before, and #478: XDebug 2.0.x can't use %R in
	  xdebug.profiler_output_name if register_long_arrays is off.

	- Fixed bug #505: %s in xdebug.trace_output_name breaks functions traces.
	- Fixed bug #494: Private attributes of parent class unavailable when
	  inheriting.
	- Fixed bug #486: feature_get -n breakpoint_types returns out of date list.
	- Fixed bug #476: Xdebug doesn't support PHP 5.3's exception chaining.
	- Fixed bug #472: Dead Code Analysis for code coverage messed up after goto.
	- Fixed bug #470: Catch blocks marked as dead code unless executed.
	- Fixed bug #469: context_get for function variables always appear as
	  "uninitialized".
	- Fixed bug #468: Property_get on $GLOBALS works only at top-level, by
	  adding GLOBALS to the super globals context.
	- Fixed bug #453: Memory leaks.
	- Fixed bug #445: error_prepend_string and error_append_string are ignored
	  by xdebug_error_cb. (Patch by Kent Davidson <kent@marketruler.com>)
	- Fixed bug #442: configure: error: "you have strange libedit".
	- Fixed bug #439: Xdebug crash in xdebug_header_handler.
	- Fixed bug #423: Conflicts with funcall.
	- Fixed bug #419: Make use of P_tmpdir if defined instead of hard coded
	  '/tmp'.
	- Fixed bug #417: Response of context_get may lack page and pagesize
	  attributes.
	- Fixed bug #411: Class/function breakpoint setting does not follow the
	  specs.
	- Fixed bug #393: eval returns array data at the previous page request.
	- Fixed bug #391: Xdebug doesn't stop executing script on catchable fatal
	  errors.
	- Fixed bug #389: Destructors called on fatal error.
	- Fixed bug #368: Xdebug's debugger bails out on a parse error with the
	  eval command.
	- Fixed bug #356: Temporary breakpoints persist.
	- Fixed bug #355: Function numbers in trace files weren't unique.
	- Fixed bug #340: Segfault while throwing an Exception.
	- Fixed bug #328: Private properties are incorrectly enumerated in case of
	  extended classes.
	- Fixed bug #249: Xdebug's error handler messes up with the SOAP
	  extension's error handler.

+ DBGP:
	- Fixed cases where private properties where shown for objects, but not
	  accessible.
	- Added a patch by Lucas Nealan (lucas@php.net) and Brian Shire
	  (shire@php.net) of Facebook to allow connections to the initiating
	  request's IP address for remote debugging.
	- Added the -p argument to the eval command as well, pending inclusion into
	  DBGP.
	- Added the retrieval of a file's execution lines. I added a new
	  un-official method called xcmd_get_executable_lines which requires the
	  stack depth as argument (-d). You can only fetch this information for
	  stack frames as it needs an available op-array which is only available
	  when a function is executed.
	- Added a fake "CLASSNAME" property to objects that are returned in debug
	  requests to facilitate deficiencies in IDEs that fail to show the "classname"
	  XML attribute.


Fri, Jul 03, 2009 - xdebug 2.0.5

= Fixed bugs:
	- Fixed bug #425: memory leak (around 40MB for each request) when using
	  xdebug_start_trace.
	- Fixed bug #422: Segfaults when using code coverage with a parse error in
	  the script.
	- Fixed bug #418: compilation breaks with CodeWarrior for NetWare.
	- Fixed bug #403: 'call' and 'return' breakpoints triggers both on call and
	  return for class method breakpoints.
	- Fixed TSRM issues for PHP 5.2 and PHP 5.3. (Original patch by Elizabeth
	  M. Smith).
	- Fixed odd crash bugs, due to GCC 4 sensitivity.


Tue, Dec 30, 2008 - xdebug 2.0.4

= Fixed bugs:
	- Fixed for strange jump positions in path analysis.
	- Fixed issues with code coverage crashing on parse errors.
	- Fixed code code coverage by overriding more opcodes.
	- Fixed issues with Xdebug stalling/crashing when detaching from remote
	  debugging.
	- Fixed crash on Vista where memory was freed with routines from a different
	  standard-C library than it was allocated with. (Patch by Eric Promislow
	  <ericp@activestate.com>).
	- Link against the correct CRT library. (Patch by Eric Promislow
	  <ericp@activestate.com>).
	- Sort the symbol elements according to name. (Patch by Eric Promislow
	  <ericp@activestate.com>).
	- Fixed support for mapped-drive UNC paths for Windows. (Patch by Eric
	  Promislow <ericp@activestate.com>).
	- Fixed a segfault in interactive mode while including a file.
	- Fixed a crash in super global dumping in case somebody was strange enough
	  to reassign them to a value type other than an Array.
	- Simplify version checking for libtool. (Patch by PGNet
	  <pgnet.trash@gmail.com>).
	- Fixed display of unused returned variables from functions in PHP 5.3.
	- Include config.w32 in the packages as well.
	- Fixed .dsp for building with PHP 4.

+ Added features:
	- Support debugging into phars.
	- Basic PHP 5.3 support.


Wed, Apr 09, 2008 - xdebug 2.0.3

= Fixed bugs:
	- Fixed bug #338: Crash with: xdebug.remote_handler=req.
	- Fixed bug #334: Code Coverage Regressions.
	- Fixed abstract method detection for PHP 5.3.
	- Fixed code coverage dead-code detection.
	- Ignore ZEND_ADD_INTERFACE, which is on a different line in PHP >= 5.3 for
	  some weird reason.

+ Changes:
	- Added a CSS-class for xdebug's var_dump().
	- Added support for the new E_DEPRECATED.


Sun, Nov 11, 2007 - xdebug 2.0.2

= Fixed bugs:
	- Fixed bug #325: DBGP: "detach" stops further sessions being established
	  from Apache.
	- Fixed bug #321: Code coverage crashes on empty PHP files.
	- Fixed bug #318: Segmentation Fault in code coverage analysis.
	- Fixed bug #315: Xdebug crashes when including a file that doesn't exist.
	- Fixed bug #314: PHP CLI Error Logging thwarted when XDebug Loaded.
	- Fixed bug #300: Direction of var_dump().
	- Always set the transaction_id and command. (Related to bug #313).


Sat, Oct 20, 2007 - xdebug 2.0.1

+ Changes:
	- Improved code coverage performance dramatically.
	- PHP 5.3 compatibility (no namespaces yet though).

= Fixed bugs:
	- Fixed bug #301: Loading would cause SIGBUS on Solaris 10 SPARC. (Patch by
	  Sean Chalmers)
	- Fixed bug #300: Xdebug does not force LTR rendering for its tables.
	- Fixed bug #299: Computerized traces don't have a newline for return
	  entries if memory limit is not enabled.
	- Fixed bug #298: xdebug_var_dump() doesn't handle entity replacements
	  correctly concerning string length.
	- Fixed a memory free error related to remote debugging conditions.
	  (Related to bug #297).


Wed, Jul 18, 2007 - xdebug 2.0.0

+ Changes:
	- Put back the disabling of stack traces - apperently people were relying
	  on this. This brings back xdebug_enable(), xdebug_disable() and
	  xdebug_is_enabled().
	- xdebug.collect_params is no longer a boolean setting. Although it worked
	  fine, phpinfo() showed only just On or Off here.
	- Fixed the Xdebug version of raw_url_encode to not encode : and \. This is
	  not necessary according to the RFCs and it makes debug breakpoints work
	  on Windows.

= Fixed bugs:
	- Fixed bug #291: Tests that use SPL do not skip when SPL is not available.
	- Fixed bug #290: Function calls leak memory.
	- Fixed bug #289: Xdebug terminates connection when eval() is run in the
	  init stage.
	- Fixed bug #284: Step_over on breakpointed line made Xdebug break twice.
	- Fixed bug #283: Xdebug always returns $this with the value of last stack
	  frame.
	- Fixed bug #282: %s is not usable for xdebug.profiler_output_name on
	  Windows in all stack frames.
	- Fixed bug #280: var_dump() doesn't display key of array as expected.
	- Fixed bug #278: Code Coverage Issue.
	- Fixed bug #273: Remote debugging: context_get does not return context id.
	- Fixed bug #270: Debugger aborts when PHP's eval() is encountered. 
	- Fixed bug #265: XDebug breaks error_get_last() .
	- Fixed bug #261: Code coverage issues by overloading zend_assign_dim.

+ DBGP:
	- Added support for "breakpoint_languages".


Wed, May 17, 2007 - xdebug 2.0.0rc4
+ Changes:
	- Use µ seconds instead of a tenths of µ seconds to avoid confusion in
	  profile information.
	- Changed xdebug.profiler_output_name and xdebug.trace_output_name to use
	  modifier tags:
	  %c = crc32 of the current working directory
	  %p = pid
	  %r = random number
	  %s = script name
	  %t = timestamp (seconds)
	  %u = timestamp (microseconds)
	  %H = $_SERVER['HTTP_HOST']
	  %R = $_SERVER['REQUEST_URI']
	  %S = session_id (from $_COOKIE if set)
	  %% = literal %

= Fixed bugs:
	- Fixed bug #255: Call Stack Table doesn't show Location on Windows.
	- Fixed bug #251: Using the source command with an invalid filename returns
	  unexpected result.
	- Fixed bug #243: show_exception_trace="0" ignored.
	- Fixed bug #241: Crash in xdebug_get_function_stack().
	- Fixed bug #240: Crash with xdebug.remote_log on Windows.
	- Fixed a segfault in rendering stack traces to error logs.
	- Fixed a bug that prevented variable names from being recorded for remote
	  debug session while xdebug.collect_vars was turned off.
	- Fixed xdebug_dump_superglobals() in case no super globals were
	  configured.

- Removed functions:
	- Removed support for Memory profiling as that didn't work properly.
	- Get rid of xdebug.default_enable setting and associated functions:
	  xdebug_disable() and xdebug_enable().

+ Added features:
	- Implemented support for four different xdebug.collect_params settings for
	  stack traces and function traces.
	- Allow to trigger profiling by the XDEBUG_PROFILE cookie.

+ DBGP:
	- Correctly add namespace definitions to XML.
	- Added the xdebug namespace that adds extra information to breakpoints if
	  available.
	- Stopped the use of <error> elements for exception breakpoints, as that
	  violates the protocol.


Wed, Jan 31, 2007 - xdebug 2.0.0rc3
+ Changes:
	- Removed the bogus "xdebug.allowed_clients" setting - it was not
	  implemented.
	- Optimized used variable collection by switching to a linked list instead
	  of a hash. This is about 30% faster, but it needed a quick conversion to
	  hash in the case the information had to be shown to remove duplicate
	  variable names.

= Fixed bugs:
	- Fixed bug #232: PHP log_errors functionality lost after enabling xdebug
	  error handler when CLI is used.
	- Fixed problems with opening files - the filename could cause double free
	  issues.
	- Fixed memory tracking as memory_limit is always enabled in PHP 5.2.1 and
	  later.
	- Fixed a segfault that occurred when creating printable stack traces and
	  collect_params was turned off.


Sun, Dec 24, 2006 - xdebug 2.0.0rc2
+ Added new features:
	- Implemented the "xdebug.var_display_max_children" setting. The default is
	  set to 128 children.
	- Added types to fancy var dumping function.
	- Implemented FR #210: Add a way to stop the debug session without having
	  to execute a script. The GET/POST parameter "XDEBUG_SESSION_STOP_NO_EXEC"
	  works in the same way as XDEBUG_SESSION_STOP, except that the script will
	  not be executed.
	- DBGP: Allow postmortem analysis.
	- DBGP: Added the non-standard function xcmd_profiler_name_get.

+ Changes:
	- Fixed the issue where xdebug_get_declared_vars() did not know about
	  variables there are in the declared function header, but were not used in
	  the code. Due to this change expected arguments that were not send to a
	  function will now show up as ??? in stack and function traces in PHP 5.1
	  and PHP 5.2.
	- Allow xdebug.var_display_max_data and xdebug.var_display_max_depth
	  settings of -1 which will unlimit those settings.
	- DBGP: Sort super globals in Globals overview.
	- DBGP: Fixed a bug where error messages where not added upon errors in the
	  protocol.
	- DBGP: Change context 1 from globals (superglobals + vars in bottom most
	  stack frame) to just superglobals.

= Fixed bugs:
	- Fixed linking error on AIX by adding libm.
	- Fixed dead code analysis for THROW.
	- Fixed oparray prefill caching for code coverage.
	- Fixed the xdebug.remote_log feature work.
	- DBGP: Fixed a bug where $this did not appear in the local scoped context.
	- DBGP: Reimplemented property_set to use the same symbol fetching function
	  as property_get. We now only use eval in case no type (-t) argument was
	  given.
	- DBGP: Fixed some issues with finding out the classname, which is
	  important for fetching private properties.
	- DBGP: Fixed usage of uninitialized memory that prevented looking up
	  numerical array keys while fetching array elements not work properly.
	- Fixed bug #228: Binary safety for stream output and property fetches.
	- Fixed bug #227: The SESSION super global does not show up in the Globals
	  scope.
	- Fixed bug #225: xdebug dumps core when protocol is GDB.
	- Fixed bug #224: Compile failure on Solaris.
	- Fixed bug #219: Memory usage delta in traces don't work on PHP 5.2.0.
	- Fixed bug #215: Cannot retrieve nested arrays when the array key is a
	  numeric index.
	- Fixed bug #214: The depth level of arrays was incorrectly checked so it
	  would show the first page of a level too deep as well.
	- Fixed bug #213: Dead code analysis doesn't take catches for throws into
	  account.
	- Fixed bug #211: When starting a new session with a different idekey, the
	  cookie is not updated.
	- Fixed bug #209: Additional remote debugging session started when
	  triggering shutdown function.
	- Fixed bug #208: Socket connection attempted when XDEBUG_SESSION_STOP.
	- Fixed PECL bug #8989: Compile error with PHP 5 and GCC 2.95.


Sun, Oct 08, 2006 - xdebug 2.0.0rc1
+ Added new features:
	- Implemented FR #70: Provide optional depth on xdebug_call_* functions.
	- Partially implemented FR #50: Resource limiting for variable display. By
	  default only two levels of nested variables and max string lengths of 512
	  are shown. This can be changed by setting the ini settings
	  xdebug.var_display_max_depth and xdebug.var_display_max_data.
	- Implemented breakpoints for different types of PHP errors. You can now
	  set an 'exception' breakpoint on "Fatal error", "Warning", "Notice" etc.
	  This is related to bug #187.
	- Added the xdebug_print_function_trace() function to display a stack trace on
	  demand.
	- Reintroduce HTML tracing by adding a new tracing option "XDEBUG_TRACE_HTML"
	  (4).
	- Made xdebug_stop_trace() return the trace file name, so that the
	  following works: <?php echo file_get_contents( xdebug_stop_trace() ); ?>
	- Added the xdebug.collect_vars setting to tell Xdebug to collect
	  information about which variables are used in a scope. Now you don't need
	  to show variables with xdebug.show_local_vars anymore for
	  xdebug_get_declared_vars() to work.
	- Make the filename parameter to the xdebug_start_trace() function
	  optional. If left empty it will use the same algorithm to pick a filename
	  as when you are using the xdebug.auto_trace setting.

+ Changes:
	- Implemented dead code analysis during code coverage for:
	  * abstract methods.
	  * dead code after return, throw and exit.
	  * implicit returns when a normal return is present.
	- Improved readability of stack traces.
	- Use PG(html_errors) instead of checking whether we run with CLI when
	  deciding when to use HTML messages or plain text messages.

= Fixed bugs:
	- Fixed bug #203: PHP errors with HTML content processed incorrectly. This
	  patch backs out the change that was made to fix bug #182.
	- Fixed bug #198: Segfault when trying to use a non-existing debug handler.
	- Fixed bug #197: Race condition fixes created too many files.
	- Fixed bug #196: Profile timing on Windows does not work.
	- Fixed bug #195: CLI Error after debugging session.
	- Fixed bug #193: Compile problems with PHP 5.2.
	- Fixed bug #191: File/line breakpoints are case-sensitive on Windows.
	- Fixed bug #181: Xdebug doesn't handle uncaught exception output
	  correctly.
	- Fixed bug #173: Coverage produces wrong coverage.
	- Fixed a typo that prevented the XDEBUG_CONFIG option "profiler_enable"
	  from working.


Fri, Jun 30, 2006 - xdebug 2.0.0beta6
+ Added new features:
	- Implemented FR #137: feature_get for general commands doesn't have a text field.
	- Implemented FR #131: XDebug needs to implement paged child object requests.
	- Implemented FR #124: Add backtrace dumping information when exception thrown.
	- Implemented FR #70: Add feature_get breakpoint_types.
	- Added profiling aggregation functions (patch by Andrei Zmievski)
	- Implemented the "timestamp" option for the xdebug.trace_output_name and
	  xdebug.profiler_output_name settings.
	- Added the xdebug.remote_log setting that allows you to log debugger
	  communication to a log file for debugging. This can also be set through
	  the "remote_log" element in the XDEBUG_CONFIG environment variable.
	- Added a "script" value to the profiler_output_name option.  This will write
	  the profiler output to a filename that consists of the script's full path
	  (using underscores). ie: /var/www/index.php becomes
	  var_www_index_php_cachegrind.out. (Patch by Brian Shire).
	- DBGp: Implemented support for hit conditions for breakpoints.
	- DBGp: Added support for conditions for file/line breakpoints.
	- DBGp: Added support for hit value checking to file/line breakpoints.
	- DBGp: Added support for "exception" breakpoints.

+ Performance improvements:
	- Added a cache that prevents the code coverage functionality from running a
	  "which code is executable check" on every function call, even if they
	  were executed multiple times. This should speed up code coverage a lot.
	- Speedup Xdebug but only gathering information about variables in scopes when
	  either remote debugging is used, or show_local_vars is enabled.

= Fixed bugs:
	- Fixed bug #184: problem with control chars in code traces
	- Fixed bug #183: property_get -n $this->somethingnonexistent crashes the
	  debugger.
	- Fixed bug #182: Errors are not html escaped when being displayed.
	- Fixed bug #180: collected includes not shown in trace files. (Patch by
	  Cristian Rodriguez)
	- Fixed bug #178: $php_errormsg and Track errors unavailable.
	- Fixed bug #177: debugclient fails to compile due to Bison.
	- Fixed bug #176: Segfault using SplTempFileObject.
	- Fixed bug #173: Xdebug segfaults using SPL ArrayIterator.
	- Fixed bug #171: set_time_limit stack overflow on 2nd request.
	- Fixed bug #168: Xdebug's DBGp crashes on an eval command where the
	  result is an array.
	- Fixed bug #125: show_mem_delta does not calculate correct negative values on
	  64bit machines.
	- Fixed bug #121: property_get -n $r[2] returns the whole hash.
	- Fixed bug #111: xdebug does not ignore set_time_limit() function during debug
	  session.
	- Fixed bug #87: Warning about headers when "register_shutdown_function" used.
	- Fixed PECL bug #6940 (XDebug ignores set_time_limit)
	- Fixed Komodo bug 45484: no member data for objects in PHP debugger.
	- Suppress NOP/EXT_NOP from being marked as executable code with Code
	  Coverage.


Sat, Dec 31, 2005 - xdebug 2.0.0beta5
+ Added new features:
	- Implemented FR #161: var_dump doesn't show lengths for strings.
	- Implemented FR #158: Function calls from the {main} scope always have the
	  line number 0. 
	- Implemented FR #156: it's impossible to know the time taken by the last
	  func call in xdebug trace mode 0.
	- Implemented FR #153: xdebug_get_declared_vars().
	
= Fixed bugs:
	- Fixed shutdown crash with ZTS on Win32
	- Fixed bad memory leak when a E_ERROR of exceeding memory_limit was
	  thrown.
	- Fixed bug #154: GCC 4.0.2 optimizes too much out with -O2.
	- Fixed bug #141: Remote context_get causes segfault.

	
Thu, Sep 24, 2005 - xdebug 2.0.0beta4
+ Added new features:
	- Added xdebug_debug_zval_stdout().
	- Added xdebug_get_profile_filename() function which returns the current
	  profiler dump file.
	- Updated for latest 5.1 and 6.0 CVS versions of PHP.
	- Added FR #148: Option to append to cachegrind files, instead of
	  overwriting.
	- Implemented FR #114: Rename tests/*.php to tests/*.inc

- Changed features:
	- Allow "xdebug.default_enable" to be set everywhere.

= Fixed bugs:
	- DBGP: Xdebug should return "array" with property get, which is defined
	  in the typemap to the common type "hash".
	- Debugclient: Will now build with an older libedit as found in FreeBSD
	  4.9.
	- Fixed bug #142: xdebug crashes with implicit destructor calls.
	- Fixed bug #136: The "type" attribute is missing from stack_get returns.
	- Fixed bug #133: PHP scripts exits with 0 on PHP error.
	- Fixed bug #132: use of eval causes a segmentation fault.

	
Thu, May 12, 2005 - xdebug 2.0.0beta3
+ Added new features:
	- Added the possibility to trigger the profiler by setting
	  "xdebug.profiler_enable_trigger" to 1 and using XDEBUG_PROFILE as a get
	  parameter.

+ Added new functions:
	- xdebug_get_profiler_filename() to retrieve the name of the dump file
	  used by profiler.

= Fixed bugs:
	- Fixed a segfault for when an attribute value is NULL on XML string
	  generation.
	- Fixed bug #118: Segfault with exception when remote debugging.
	- Fixed bug #117: var_dump dows not work with "private".
	- Fixed bug #109: DBGP's eval will abort the script when the eval statement
	  is invalid.
	- Fixed bug #108: log_only still displays some text for errors in included
	  files.
	- Fixed bug #107: Code Coverage only detects executable code in used
	  functions and classes.
	- Fixed bug #103: crash when running the DBGp command 'eval' on a global
	  variable
	- Fixed bug #95: Segfault when deinitializing Xdebug module.
	  (Patch by Maxim Poltarak <demiurg@gmail.com>)


Sun, Nov 28, 2004 - xdebug 2.0.0beta2
+ Added new features:
	- DBGP: Added error messages to returned errors (in most cases)
  
+ Added new functions:
	- xdebug_debug_zval() to debug zvals by printing its refcounts and is_ref
	  values.
  
= Changed features:
	- xdebug_code_coverage_stop() will now clean up the code coverage array,
	  unless you specify FALSE as parameter.
	- The proper Xdebug type is "hash" for associative arrays.
	- Extended the code-coverage functionality by returning lines with
	  executable code on them, but where not executed with a count value of -1.

= Fixed bugs:
	- DBGP: Make property_get and property_value finally work as they should,
	  including retrieving information from different depths then the most top
	  stack frame.
	- DBGP: Fix eval'ed $varnames in property_get.
	- DBGP: Support the -d option for property_get.
	- Fixed the exit handler hook to use the new "5.1" way of handling it;
	  which fortunately also works with PHP 5.0.
	- Fixed bug #102: Problems with configure for automake 1.8.
	- Fixed bug #101: crash with set_exeception_handler() and uncatched exceptions.
	- Fixed bug #99: unset variables return the name as a string with property_get.
	- Fixed bug #98: 'longname' attribute not returned for unintialized
	  property in context_get request.
	- Fixed bug #94: xdebug_sprintf misbehaves with x86_64/glibc-2.3.3
	- Fixed bug #93: Crash in lookup_hostname on x86_64
	- Fixed bug #92: xdebug_disable() doesn't disable the exception handler.
	- Fixed bug #68: Summary not written when script ended with "exit()".


Wed, Sep 15, 2004 - xdebug 2.0.0beta1
+ Added new features:
	- Added support for the new DBGp protocol for communicating with the debug
	  engine.
	- A computerized trace format for easier parsing by external programs.
	- The ability to set remote debugging features via the environment.  This
	  allows an IDE to emulate CGI and still pass the configuration through to
	  the debugger.  In CGI mode, PHP does not allow -d arguments.
	- Reimplementation of the tracing code, you can now only trace to file; this greatly
	  enhances performance as no string representation of variables need to be
	  kept in memory any more.
	- Re-implemented profiling support. Xdebug outputs information the same way
	  that cachegrind does so it is possible to use Kcachegrind as front-end.
	- Xdebug emits warnings when it was not loaded as a Zend extension.
	- Added showing private, protected and public to the fancy var_dump()
	  replacement function.
	- Added the setting of the TCP_NODELAY socket option to stop delays in
	  transferring data to the remote debugger client. (Patch by Christof J.  Reetz)
	+ DebugClient: Added setting for port to listen on and implemented running
	  the previous command when pressing just enter.

+ Added new functions:
	- xdebug_get_stack_depth() to return the current stack depth level.
	- xdebug_get_tracefile_name() to retrieve the name of the tracefile. This
	  is useful in case auto trace is enabled and you want to clean the trace
	  file.
	- xdebug_peak_memory_usage() which returns the peak memory
	  used in a script. (Only works when --enable-memory-limit was enabled)

+ Added feature requests:
	- FR #5: xdebug_break() function which interupts the script for the debug
	  engine.
	- FR #30: Dump current scope information in stack traces on error.
	- FR #88: Make the url parameter XDEBUG_SESSION_START optional. So it can
	  be disabled and the user does not need to add it.

+ Added new php.ini settings:
	- xdebug.auto_trace_file: to configure a trace file to write to as addition
	  to the xdebug.auto_trace setting which just turns on tracing.
	- xdebug.collect_includes: separates collecting
	  names of include files from the xdebug.collect_params setting.
	- xdebug.collect_return: showing return values in traces.
	- xdebug.dump_global: with which you can turn off dumping of super globals
	  even in you have that configured.
	- xdebug.extended_info: turns off the generation of extended opcodes that
	  are needed for stepping and breakpoints for the remote debugger. This is
	  useful incase you want to profile memory usage as the generation of this
	  extended info increases memory usage of oparrrays by about 33%. 
	- xdebug.profiler_output_dir: profiler output directory.
	- xdebug.profiler_enable: enable the profiler.
	- xdebug.show_local_vars: turn off the showing of local variables in the
	  top most stack frame on errors.
	- xdebug.show_mem_delta: show differences between current and previous
	  memory usage on a function call level.
	- xdebug.trace_options: to configure extra
	  options for trace dumping:
		o XDEBUG_TRACE_APPEND option (1)

= Changed features:
	- xdebug_start_trace() now returns the filename of the tracefile (.xt is
	  added to the requested name).
	- Changed default debugging protocol to dbgp instead of gdb.
	- Changed default debugger port from 17869 to 9000.
	- Changed trace file naming: xdebug.trace_output_dir is now used to
	  configure a directory to dump automatic traces; the trace file name now
	  also includes the pid (xdebug.trace_output_name=pid) or a crc32 checksum
	  of the current working dir (xdebug.trace_output_name=crc32) and traces
	  are not being appended to an existing file anymore, but simply
	  overwritten.
	- Removed $this and $GLOBALS from showing variables in the local scope.

- Removed functions:
	- xdebug_get_function_trace/xdebug_dump_function_trace() because of the new
	  idea of tracing.

= Fixed bugs:
	- Fixed bug #89: var_dump shows empty strings garbled.
	- Fixed bug #85: Xdebug segfaults when no idekey is set.
	- Fixed bug #83: More than 32 parameters functions make xdebug crash.
	- Fixed bug #75: xdebug's var_dump implementation is not binary safe.
	- Fixed bug #73: komodo beta 4.3.7 crash.
	- Fixed bug #72: breakpoint_get returns wrong structure.
	- Fixed bug #69: Integer overflow in cachegrind summary.
	- Fixed bug #67: Filenames in Xdebug break URI RFC with spaces.
	- Fixed bug #64: Missing include of xdebug_compat.h.
	- Fixed bug #57: Crash with overloading functions.
	- Fixed bug #54: source command did not except missing -f parameter.
	- Fixed bug #53: Feature get misusing the supported attribute.
	- Fixed bug #51: Only start a debug session if XDEBUG_SESSION_START is
	  passed as GET or POST parameter, or the DBGP_COOKIE is send to the server.
	  Passing XDEBUG_SESSION_STOP as GET/POST parameter will end the debug
	  session and removes the cookie again. The cookie is also passed to the
	  remote handler backends; for DBGp it is added to the <init> packet.
	- Fixed bug #49: Included file's names should not be stored by address.
	- Fixed bug #44: Script time-outs should be disabled when debugging.
	- Fixed bug #36: GDB handler using print causes segfault with wrong syntax
	- Fixed bug #33: Implemented the use of the ZEND_POST_DEACTIVATE hook. Now we
	  can handle destructors safely too.
	- Fixed bug #32: Unusual dynamic variables cause xdebug to crash.


Fri, Dec 26, 2003 - xdebug 1.3.0

+ GDB: Added file/line to signals. (Derick)
= Fixed logging to adhere to the error_reporting setting. (Derick)
= Fixed bug #32: Unusual dynamic variables cause xdebug to crash. (Ilia)
= Fixed bug #31: & entity replaced after others, wrong HTML output. (Derick)
= Fixed bug #22: Segmentation fault with xdebug_get_function_stack() and
  collect_params=1. (Derick)


Tue, Nov 08, 2003 - xdebug 1.3.0rc2

+ Added version info to handlers which show in phpinfo() output. (Derick)
= GDB: Fixed bug with continuing after breakpoint where only 'cont' worked.
  (Derick)
= GDB: Fixed bug in deleting absolute breakpoints on Windows. (Derick)
= Fixed bug #27: Repeated connect attempts when no debugger is listening.
  (Derick)
= Fixed bug #19: The value of xdebug.output_dir in a .htaccess never takes
  effect. (Derick)
= Fixed bug #18: Mistyped sizeof()'s for array indexes in profiler output.
  (Derick)
= Fixed handling stack traces for when display_errors was set to Off. (Derick)
= Fixed segfault where a function name didn't exist in case of a
 "call_user_function". (Derick)
= Fixed reading a filename in case of an callback to a PHP function from an
  internal function (like "array_map()"). (Derick)


Thu, Sep 18, 2003 - xdebug 1.3.0rc1

= Fixed bug with wrong file names for functions called from call_user_*().
  (Derick)
+ Added the option "dump_superglobals" to the remote debugger. If you set this
  option to 0 the "show-local" and similar commands will not return any data
  from superglobals anymore. (Derick)
= Fixed bug #2: "pear package" triggers a segfault. (Derick)
= Fixed crash bug when a function had sprintf style parameters (ie.
  strftime()). (Derick)
+ Added "id" attribute to <var /> elements in responses from the remove
  debugger when the response method is XML. This makes it possible to
  distinguish between unique elements by use of recursion for example. (Derick)
= Improved performance greatly by doing lazy folding of variables outside
  trace mode. (Derick)
= Fixed a bug with "quit", if it was used it disabled the extension for the
  current process. (Derick)
+ Added the "full" argument to the remote command "backtrace". When this
  argument is passed, the local variables will be returned to for each frame in
  the stack. (Derick)
+ Implemented xdebug_time_index() which returns the time passed since the
  start of the script. This change also changes the output of the tracing
  functions as the start time will no longer be the first function call, but
  the real start time of the script. (Derick)
+ Implemented the "show-local" command (shows all local variables in the
  current scope including all contents). (Derick)
+ Implemented conditions for breakpoints in the "break" command. (Derick)


Mon, Apr 21, 2003 - xdebug 1.2.0

= Fixed compilation on MacOSX. (Derick)


Tue, Apr 15, 2003 - xdebug 1.2.0rc2

= Fixed handling Windows paths in the debugger. (Derick)
= Fixed getting zvals out of Zend Engine 2. (Derick)


Sun, Apr 6, 2003 - xdebug 1.2.0rc1

+ Added code coverage functions to check which lines and how often they were
  touched during execution. (Derick)
+ Made Xdebug compatible with Zend Engine 2. (Derick)
+ Added dumping of super globals on errors. (Harald Radi)
+ Added XML protocol for the debugger client. (Derick)
= Fixed handling of "continue" (so that it also continues with the script).
  (Derick)
+ Additions to the remote debugger: "eval" (evaluate any PHP code from the
  debugger client). (Derick)
+ Added profiling support to xdebug. This introduces 3 new functions,
  xdebug_start_profiling() that begins profiling process, 
  xdebug_stop_profiling() that ends the profiling process and
  xdebug_dump_function_trace() that dumps the profiling data. (Ilia)
+ Implemented the "kill" (kills the running script) and "delete" (removes
  a breakpoint on a specified element) command. (Derick)


Wed Nov 11, 2002 - xdebug 1.1.0

+ Implemented the "list" (source listing), "print" (printing variable
  contents), "show" (show all variables in the scope), "step" (step through
  execution), "pwd" (print working directory), "next" (step over) and "finish"
  (step out) commands for the remote debugger. (Derick)
= Fixed lots of small bugs, under them memory leaks and crash bugs. (Derick)
= Parameters to functions are no longer recorded by default; use the
  xdebug.collect_params=1 setting in php.ini to turn it on again.


Tue Oct 29, 2002 - xdebug 1.1.0pre2

+ Implemented class::method, object->method and file.ext:line style
  breakpoints. (Derick)
= Changed debugger port from 7869 to 17869. (Derick)
+ Added xdebug.collect_params setting. If this setting is on (the default)
  then Xdebug collects all parameters passed to functions, otherwise they
  are not collected at all. (Derick)
+ Implemented correct handling of include/require and eval. (Derick)


Mon Oct 22, 2002 - xdebug 1.1.0pre1

+ Added automatic starting of function traces (xdebug.auto_trace, defaulting to
  "off"). (Derick)
- Xdebug no longer supports PHP versions below PHP 4.3.0pre1. (Derick)
+ Added gdb compatible debugger handler with support for simple (function only)
  breakpoints. (Derick)
= Implemented a new way to get class names and file names. (Derick, Thies C.
  Arntzen <thies@thieso.net>)
+ Added time-index and memory footprint to CLI dumps. (Derick)
+ Implemented remote debugger handler abstraction. (Derick)
+ Added a php3 compatible debugger handler. (Derick)


Sun Sep 1, 2002 - xdebug 1.0.0rc1

+ Implemented gathering of parameters to internal functions (only available
  in combination with PHP 4.3.0-dev). (Derick)
= Implemented a new way to get class names and file names. (Derick, Thies C.
  Arntzen <thies@thieso.net>)
+ Added support for error messages with stack trace in syslog. (Sergio
  Ballestrero <s.ballestrero@planetweb.it>)
= Windows compilation fixes. (Derick)


Sun Jun 23, 2002 - xdebug 0.9.0

= Fixed a problem with output buffering in PHP. (Derick)
= Fixed a memory leak in delayed included files. (Derick)
+ Added support for PHP 4.1.2. (Derick)
= Rewrote xdebug_get_function_stack() and xdebug_get_function_trace() to return
  data in multidimensional arrays. (Derick)
= Fixed compiling without memory limit enabled (Sander Roobol, Derick)
+ Add support for classnames, variable include files and variable
  function names. (Derick)
+ Implemented links to the PHP Manual in traces. (Derick)
+ Added timestamps and memory usage to function traces. (Derick)
= Fixed crash when using an user defined session handler. (Derick)
+ Implemented variable function names ($a = 'foo'; $f();) for use in
  traces. (Derick)


Sun May 26, 2002 - xdebug 0.8.0 - Yoda

+ Implemented much better parameter tracing for user defined
  functions. (Derick)
= Renamed xdebug_get_function_trace() to xdebug_dump_function_trace().
  (Derick)
= Implemented new xdebug_get_function_trace() to return the function trace in
  an array. (Derick)
+ Added a parameter to xdebug_start_trace(). When this parameter is used,
  xdebug will dump a function trace to the filename which this parameter
  speficies. (Derick)
+ Fix a problem with nested member functions. (Derick)
= Make configure scripts work with PHP 4.2.x. (Derick)
+ Implemented handling single-dimensional constant arrays passed to a
  function. (Derick)
= Fix function traces in windows. (Derick)
+ Implemented function traces, which you can start and stop with
  xdebug_start_trace() and xdebug_stop_trace(). You can view the trace by using
  the return array from xdebug_get_function_trace(). (Derick)
= Fixed segfaults with xdebug_call_*(). (Derick)


Wed May 08, 2002 - xdebug 0.7.0 - Freedom

+ Implemented handling of static method calls (foo::bar). (Derick)
+ Added correct handling of include(_once)/require(_once) and eval().
  (Derick)
+ Added ini setting to change the default setting for enabling showing
  enhanced error messages. (Defaults to "On"). (Derick)
+ Added the functions xdebug_enable() and xdebug_disable() to change the
  showing of stack traces from within your code. (Derick)
= Fixed the extension to show all errors. (Derick)
+ Implemented xdebug_memory_usage() which returns the memory in use by PHPs
  engine. (Derick)


Legenda:
+ New additions
- Removed functions
= Bug fixes / Changes
